package com.casic.dcms.mvp.model;

import com.casic.dcms.bean.ActionResultBean;
import com.casic.dcms.utils.retrofit.RetrofitServiceManager;

import rx.Observable;
import rx.Observer;
import rx.Subscription;
import rx.android.schedulers.AndroidSchedulers;
import rx.schedulers.Schedulers;

public class UploadPositionModelImpl implements IUploadPositionModel {

    private OnUpdateListener listener;

    public UploadPositionModelImpl(OnUpdateListener updateListener) {
        this.listener = updateListener;
    }

    @Override
    public Subscription sendRetrofitRequest(String imei, String positionLat, String positionLng) {
        Observable<ActionResultBean> observable = RetrofitServiceManager.getPositionUploadResult(imei, positionLat, positionLng);
        return observable.subscribeOn(Schedulers.io()).observeOn(AndroidSchedulers.mainThread()).subscribe(new Observer<ActionResultBean>() {
            @Override
            public void onCompleted() {

            }

            @Override
            public void onError(Throwable e) {
                if (e.getCause() != null) {
                    listener.onFailure(e);
                }
            }

            @Override
            public void onNext(ActionResultBean resultBean) {
                if (resultBean != null) {
                    listener.onSuccess(resultBean);
                }
            }
        });
    }

    public interface OnUpdateListener {
        void onSuccess(ActionResultBean resultBean);

        void onFailure(Throwable throwable);
    }
}
